        subttl Installation routine
        page +

;
; VFOS_IBM FOSSIL driver by Bob Hartman;
;                 modifications by Johan Zwiekhorst.
; Copyright 1988 by Spark Software.  ALL RIGHTS RESERVED.
;

Resend  Equ     $                         ;Resident code ends here

my_intro Db      'VFOS_IBM VFOSSIL Compatible Driver '

rev_str db  '$Revision: ',curr_fossil+'0','.',curr_maj_rev+'0',curr_min_rev+'0','$'
crlflf  Db      13,10,10,'$'

got_1   Db	13,10,'Another (supposedly) compatible driver has already been loaded!',13,10,'$'

bad_1   Db	13,10,'Bad return from regular FOSSIL when attempting to install VFOSSIL!',13,10,'$'

str2    Db  '(C) Copyright 1988 by Bob Hartman and Spark Software, Inc.',13,10,'Modifications (C) Copyright 1992 by Johan Zwiekhorst.',13,10,'$'


start:                                    ;Initialization code

	MOV	DX,OFFSET my_intro      ; print first string
	MOV	AH,9
	INT	21H
	MOV	DX,OFFSET rev_str	; print first string
	INC	DX
	MOV	AH,9
	INT	21H
	MOV	DX,OFFSET crlflf        ; print cr's and lf's
	MOV	AH,9
	INT	21H
	MOV	DX,OFFSET str2		; print second string
	MOV	AH,9
	INT	21H
		
;        check if a driver is already present

        mov     ah,81h                  ;VFOSSIL application code
        mov     al,0                    ;subfunction 0 to get info
        mov     di,offset vfos_info     ;structure to store info
        push    es                      ;save ES
        push    cs                      ;put CS into
        pop     es                      ;ES
        int     14h                     ;call the function

        cmp     ax,1954h                ; was it a proper return?
        je      already_there           ; yes, so just exit

        mov     ah,7eh                  ; install application code
        mov     al,81h                  ; VFOSSIL code
        mov     dx,offset vfos_entry    ; offset of entry point (es ok)
        int     14h                     ; initialize it

        cmp     ax,1954h                ; good return?
        jne     bad_fossil              ; no, say it was bad
        cmp     bh,1                    ; was it installed
        jne     bad_fossil              ; no, say it was bad

; make sure the table is properly set up (do our own relocation!)

        mov     di,offset FUNCTBL
        mov     ax,cs
        mov     es,ax
        add     di,2
        mov     cx,20

str_loop:
        stosw
        add     di,2
        loop    str_loop

; now set up the base address of the adapter
        mov     ah,0fh
        int     10h
        cmp     al,7
        jne     env_free
        mov     ax,0b000h
        mov     adapter_base,ax

; set up correct video parameters (*JZ*)
        mov     ax,40h                    ; BIOS data segment
        mov     es,ax
        mov     ax,es:[4Ah]               ; get number of screen columns
        mov     mode_info.mode_cols,ax
        xor     ah,ah
        mov     al,es:[84h]               ; get number of screen rows
        cmp     al,24                     ; more than 25?
        jle     norw                      ; no, don't change anything
        inc     al
        mov     mode_info.mode_rows,ax
norw:

; Free our environment memory segment
env_free:
        push    cs
        pop     ds
        mov     bx,2ch
        mov     ax,[bx]
        mov     es,ax
        mov     ah,49h
        int     21h

;       And finally, terminate but leave resident code
;       Use the old Int 27 call for DOS 1.x compatability.

        pop     es
	mov	dx,offset resend
        Int     27H                       ;Use Int 27 for DOS 1.0 Compatability

already_there:
        mov     dx,offset got_1
        jmp     SHORT nogo

bad_fossil:
        mov     dx,offset bad_1

nogo:
	pop	es
        mov     ah,9                ;print string
        int     21h
        int     20h                 ;terminate
code    ends
	end vfos_ibm

